{ lib
, stdenv
, fetchgit
, nix-update-script
, meson
, ninja
, gettext
, desktop-file-utils
, cargo
, rustPlatform
, rustc
, pkg-config
, glib
, libadwaita
, libhandy
, gtk4
, openssl
, alsa-lib
, libpulseaudio
, wrapGAppsHook4
, blueprint-compiler
, gst_all_1
}:

rustPlatform.buildRustPackage rec {
  pname = "spot";
  version = "0.6.0";

  src = fetchgit {
    url = "https://github.com/stevenleadbeater/spot.git";
    rev = "b2291e0834d9a1a6e7ce1020fc88c483dfbc0b24";
    hash = "sha256-JFBwTAYKBwmjUI3B67zB60dLM+DjIzzbO/1iLsn+5TE=";
  };
  cargoHash = "sha256-HIjA+oDFegsnnV3EViaWfsNhmqPB1yl8rIVS5LbTu/A=";

  nativeBuildInputs = [
    gettext
    meson
    ninja
    pkg-config
    gtk4 # for gtk-update-icon-cache
    glib # for glib-compile-schemas
    desktop-file-utils
    cargo
    rustPlatform.cargoSetupHook
    rustc
    wrapGAppsHook4
    blueprint-compiler
  ];

  buildInputs = [
    glib
    gtk4
    libadwaita
    libhandy
    openssl
    alsa-lib
    libpulseaudio
    gst_all_1.gst-plugins-base
    gst_all_1.gstreamer
  ];

  # https://github.com/xou816/spot/issues/313
  mesonBuildType = "release";

  meta = {
    description = "Native Spotify client for the GNOME desktop";
    mainProgram = "spot";
    homepage = "https://github.com/stevenleadbeater/spot";
    maintainers = [];
  };
}

